
;manifest file

;########################################################################

        INCLUDE CapsLock.inc

;########################################################################

        .DATA

InitFlag        dd 0
szTitle         db 'Caps Lock State Demo',0
szTTClass       db 'tooltips_class32',0
MsgEcTt1        db 'Caps Lock is On',13,10,13,10
                db 'Having Caps Lock on may cause you to enter your User ID incorrectly.',0
MsgEcTt2        db 'Caps Lock is On',13,10,13,10
                db 'Having Caps Lock on may cause you to enter your Password incorrectly.',0

;************************************************************************

        .DATA?

hDlg            dd ?
hInstance       dd ?
hHook           dd ?
CapsState       dd ?
FocusHandle     dd ?

ecs1 EditCtrlStruc <>
ecs2 EditCtrlStruc <>

;########################################################################

        .CODE

DlgProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov     ecx,uMsg
	cmp     ecx,WM_KEYDOWN
        jz      dProc0

        cmp     ecx,WM_COMMAND
        jnz     dProc2

;-----------------------------------------

;WM_COMMAND

;wParam low word = control identifier
;wParam high word = notification code
;lParam = control handle

        movzx   ecx,word ptr wParam+2  ;convert lParam high word to dword
        mov     edx,lParam             ;EDX = hEdit
        cmp     ecx,EN_SETFOCUS
        jz      enSetFocus

        cmp     ecx,EN_KILLFOCUS
        jnz     dProc3

;WM_COMMAND:EN_KILLFOCUS

        cmp     edx,FocusHandle
        jnz     dProc3

        mov     FocusHandle,0
        jmp     dProc3

;WM_COMMAND:EN_SETFOCUS

enSetFocus:
        cmp     edx,FocusHandle
        jz      dProc3

        mov     FocusHandle,edx

;WM_KEYDOWN (only sent by our hook)

dProc0: mov     ecx,FocusHandle
        mov     edx,ecs1.hTool
        mov     eax,ecs2.hTool
        jecxz   dProc1

        cmp     ecx,ecs1.hEdit
        mov     ecx,CapsState
        jz      dProc1

        xchg    eax,edx

dProc1: push    eax
        INVOKE  SendMessage,edx,TTM_ACTIVATE,ecx,0
        pop     eax
        INVOKE  SendMessage,eax,TTM_ACTIVATE,FALSE,0
        jmp short dProc3

;-----------------------------------------

dProc2: cmp     ecx,WM_SIZE
        jz      dProc4

        cmp     ecx,WM_INITDIALOG
        jz      dProc5

        cmp     ecx,WM_CLOSE
        jz      dProc6

dProc3: xor     eax,eax  
        ret

;-----------------------------------------

;WM_SIZE

;we use WM_SIZE to tell us when the dialog
;box has been displayed for the first time
;otherwise, we get no tooltip activation for the first set focus

dProc4: cmp     ecx,InitFlag
        jz      dProc3

        mov     InitFlag,ecx
        jmp     dProc0

;-----------------------------------------

;WM_INITDIALOG

dProc5: push    ebx
        push    esi
        mov     ebx,hWnd
        push    edi
        mov     hDlg,ebx
        INVOKE  SetWindowText,ebx,offset szTitle
        INVOKE  LoadIcon,hInstance,IDI_ICON 
        xchg    eax,edi
        mov     esi,WM_SETICON
        INVOKE  PostMessage,ebx,esi,ICON_SMALL,edi
        INVOKE  PostMessage,ebx,esi,ICON_BIG,edi

;**********************************

;initialize CapsState variable

        xor     edi,edi
        INVOKE  GetKeyState,VK_CAPITAL
        and     eax,1
        mov     CapsState,eax

;insert keyboard hook

        INVOKE  GetCurrentThreadId
        INVOKE  SetWindowsHookEx,WH_KEYBOARD,KeyboardProc,edi,eax
        mov     hHook,eax

;create tooltips

        mov     esi,offset ecs1
        mov     eax,IDC_EDT1
        mov     [esi].EditCtrlStruc.lpTtText,offset MsgEcTt1
        call    TtCreate
        mov     FocusHandle,eax
        INVOKE  SetFocus,eax
        mov     esi,offset ecs2
        mov     eax,IDC_EDT2
        mov     [esi].EditCtrlStruc.lpTtText,offset MsgEcTt2
        call    TtCreate

;**********************************

        pop     edi
        pop     esi
        pop     ebx
        jmp     dProc3

;-----------------------------------------

;WM_CLOSE

;**********************************

;remove keyboard hook

dProc6: INVOKE  UnhookWindowsHookEx,hHook

;**********************************

        INVOKE  EndDialog,hWnd,0
        jmp     dProc3

DlgProc ENDP

;************************************************************************

KeyboardProc PROC nCode:SDWORD,wParam:WPARAM,lParam:LPARAM

;keyboard hook proc - adapted from example code by MichaelW

        test byte ptr nCode+3,80h       ;if nCode is negative, call next hook
        jz      kProc1

        INVOKE  CallNextHookEx,hHook,nCode,wParam,lParam

kProc0: ret

kProc1: mov     eax,VK_CAPITAL
        cmp     eax,wParam              ;only caps lock key
        jnz     kProc0

        test byte ptr lParam+3,40h      ;only key down - not key up
        jnz     kProc0

        INVOKE  GetKeyState,eax
        and     eax,1                   ;"toggle state" bit only
        mov     CapsState,eax
        INVOKE  PostMessage,hDlg,WM_KEYDOWN,wParam,lParam
        jmp     kProc0

KeyboardProc ENDP

;************************************************************************

TtCreate PROC

;create a tooltip window

;Call With: EAX = edit box control ID
;           EBX = hDlg
;           ESI = address of edit control structure
;           EDI = 0
;
;  Returns: EAX = hEdit
;           ESI = hTool

        INVOKE  GetDlgItem,ebx,eax
        mov     [esi].EditCtrlStruc.hEdit,eax
        push    eax
        INVOKE  CreateWindowEx,WS_EX_TOOLWINDOW,offset szTTClass,edi,WS_POPUP or TTS_BALLOON,
                CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,ebx,edi,hInstance,edi
        mov     [esi].EditCtrlStruc.hTool,eax
        push    edi                                  ;TOOLINFO.lParam
        push    [esi].EditCtrlStruc.lpTtText         ;TOOLINFO.lpszText
        push    hInstance                            ;TOOLINFO.hInst
        push    edi                                  ;TOOLINFO.rect.bottom
        push    edi                                  ;TOOLINFO.rect.right
        push    edi                                  ;TOOLINFO.rect.top
        push    edi                                  ;TOOLINFO.rect.left
        push    [esi].EditCtrlStruc.hEdit            ;TOOLINFO.uId
        push    ebx                                  ;TOOLINFO.hWnd
        push    TTF_IDISHWND or TTF_SUBCLASS         ;TOOLINFO.uFlags
        push    sizeof TOOLINFO                      ;TOOLINFO.cbSize
        INVOKE  SendMessage,eax,TTM_ADDTOOL,edi,esp
        mov     esi,[esi].EditCtrlStruc.hTool
        INVOKE  SendMessage,esi,TTM_SETMAXTIPWIDTH,edi,180
        INVOKE  SendMessage,esi,TTM_ACTIVATE,edi,edi
        add     esp,sizeof TOOLINFO
        pop     eax
        ret

TtCreate ENDP

;************************************************************************

_main   PROC

        xor     edi,edi
        push    ICC_WIN95_CLASSES
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        INVOKE  DialogBoxParam,eax,IDD_DIALOG1,edi,DlgProc,edi
        INVOKE  ExitProcess,edi

_main   ENDP

;########################################################################

        END     _main

